



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux主机SSH免密设置解析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux主机SSH免密设置解析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-22 05:41:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>为了保证一台Linux主机的安全，所以我们每个主机登录的时候一般我们都设置账号密码登录。但是很多时候为了操作方便，我们都通过设置SSH免密码登录。那么该如何设置？是不是免密码登录就不安全了呢？</p>
<p>一、被访问主机的秘钥存储机制</p>
<p>在被SSH登录的主机中，其实都有一个存储来登录的主机的秘钥的文件，它的名字叫做authorized_keys，它的位置就在root/下面的隐藏目录.ssh中(注：如果这台主机没有被设置任何免秘钥登录，这个文件缺省是不存在的)</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161126223609243?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p>在authorized_keys文件中，存储着能够登录本地主机的各个主机的身份证信息，他们的存储格式都是以ssh-rsa开头的一组字符串。在这里，我们不用理解他的意义，但是要记住两点：</p>
<p>1.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;每个ssh-rsa及其之后字符串组成了一个唯一代表一个主机的秘钥；</p>
<p>2.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;这个秘钥是无法被仿照的；</p>
<p>二、SSH免密登录设置</p>
<p>（1）从Linux系统下发起免密登录</p>
<p>目标机器： HostA</p>
<p>本地机器： HostB</p>
<p>a.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;在本地机器用ssh-keygen 生成一个公私钥对</p>
<p>[root@HostB ~] ssh-keygen</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161126224229902?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p>此时，在/root/下会生成一个.ssh目录，在这个目录下会生成两个文件</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161126224248236?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p>id_rsa是私钥，一定要保存好。不能丢失，也绝对不能分发给其他的用户。如果私钥丢失，身份就可能会被别人冒充。</p>
<p>id_rsa.pub是公钥，用来对外做分发用的。其他的主机拿到公钥之后，就能够判断私钥是否准确。</p>
<p>b.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;把本地生成的公钥拷贝到需要登录的目标主机上</p>
<p>[root@HostB &nbsp;~]scp&nbsp;.ssh/id_rsa.pub&nbsp;root@192.168.1.181:/home/</p>
<p>c.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;在远程主机上，将公钥添加到authorized_keys文件之后</p>
<p>[root@HostA &nbsp;~]cat&nbsp;id_rsa.pub&nbsp;&gt;&gt;&nbsp;.ssh/authorized_keys</p>
<p>[root@HostA &nbsp;~]chmod 700&nbsp;.ssh</p>
<p>[root@HostA &nbsp;~]chmod&nbsp;600&nbsp;.ssh/authorized_keys</p>
<p>这里要注意两点：</p>
<p>1）&nbsp;这里是目标主机HostA，而不是发起主机HostB</p>
<p>2）&nbsp;这里需要用cat命令将公钥中的内容用重定向命令&gt;&gt;添加到authorized_keys文件之后，而不能简单的用cp命令。原因是因为authorized_keys里面以前可能添加过秘钥，如果用cp命令，可能将以前的秘钥都冲掉。</p>
<p>d.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;上述步骤都完成后，免密登录都已经设置完成，可以回到本地主机上进行SSH登录了</p>
<p>摘自：http://blog.csdn.net/royalfizz/article/details/53356584</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdd0ozq.html">python的编码规范【摘】</a>
		</li>
						<li><a href="https://www.batexi.com/a/495me3mq.html">Codeforces 747D：Winter Is Coming（贪心）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o7gwlq.html">js 猜数字游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xl3nr9.html">MySQL数据库添加一个字段</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde10gv9.html">C&plus;&plus;11的资源管理：泛化的RAII</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mve2xq.html">notepad&plus;&plus;下载Subversion插件，显示intalltion of subversion failed</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd25vy8.html">大型分布式C&plus;&plus;框架《一：框架简介》</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okerr19.html">jQuery模拟点击A标记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoel01q.html">ligerUI---ligerGrid中treegrid&lpar;表格树&rpar;的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdr47d9.html">课下作业MyCP的分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jpjp38.html">stat  文件三个时间点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0jdxq.html">Topshelf的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv256jj9.html">记一次JDK升级带来的连环反应</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy0lmjq.html">UVaLive 4064 Magnetic Train Tracks &lpar;极角排序&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj0k1e9.html">springMVC入门&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1r34pq.html">【紫书】Urban Elevations UVA - 221  离散化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll37g6q.html">Caused by&colon; java&period;sql&period;SQLException&colon; Field &amp;&num;39&semi;category&lowbar;id&amp;&num;39&semi; doesn&amp;&num;39&semi;t have a default value</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pyxxw8.html">简单分享apache封IP的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2krjz8.html">使用C&num;反射机制访问类的私有成员【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkl5od8.html">wpf mvvm模式下的image绑定</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qljp30k9.html">JavaScript中的内存泄漏以及如何处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpryovq.html">CocoaPods 安装及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoewe3q.html">osap一站式分析模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mer0x0q.html">mysql之ALTER COLUMN、CHANGE COLUMN、MODIFY COLUMN的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzd3708.html">mysql数据库相关知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojleeeq.html">&lbrack;最短路&rsqb;P1339 &lbrack;USACO09OCT&rsqb;热浪Heat Wave</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj4pvk8.html">android 圆角 ImageView</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z06vg9.html">京东分布式缓存redis应用实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgkooe8.html">pymysql 模块介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzdyel8.html">Smarty基础用法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
